* II2MM - Intel to Motorola and vice versa, ie endian conversion
*
* pjwitte 2o22+
* All code is my own work except as and where stated
*
* V0.01
*
* Compatible with QDOS, Minerva and SMSQ/E
*
* Note: If added to a larger toolkit perhaps change getp and associated
* code to ut_gxin1 and ut_gxlin to shave off a few bytes..
*

        section code

        xdef II2MM_W,II2MM_L

        xref l2frtr

        include dev8_keys_sbasic
        include dev8_keys_qlv
        include dev8_keys_err


*
II2MM_W
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* MM% = II2MM_W%(unsigned integer%)
*

        bsr.s getp

        move.l d1,d0
        swap d1
        cmpi.w #$ffff,d1
        beq.s neg

        tst.w d1
        bne.s err_ov

neg
        addq.l #2,sb_arthp(a6)
        movea.l sb_arthp(a6),a1

        rol.w #8,d0
        move.w d0,(a6,a1.l)

        moveq #ar.int,d4

        moveq #0,d0
        rts

*
getp
        move.w sb.gtlin,a2
        jsr (a2)
        bne.s exit

        subq.w #1,d3
        bne.s err_bp

        move.l (a6,a1.l),d1
        rts

*
II2MM_L
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* MM = II2MM_L(long integer)
*
* values > 2^31 - 1 must be given as signed numbers, eg 2^31 => -2^31,
* 2^31 + 1 => -2^31 + 1.. 2^32 - 1 => -1



        bsr.s getp

        addq.l #4,sb_arthp(a6)

        rol.w #8,d1
        swap d1
        rol.w #8,d1

        bra l2frtr

*
err_bp
        moveq #err.ipar,d0

*
exit
        addq.l #4,sp
        rts

*
err_ov
        moveq #err.ovfl,d0
        rts
*
        end
